function IsValidTab() {
    return location.href.includes('/LicenseMonitor') ||
        location.href.includes('/Log') ||
        location.href.includes('/Configuration') ||
        location.href.includes('/CheckoutHistory') ||
        location.href.includes('/DefaultCharts') ||
        location.href.includes('/CustomChart');
}
if (!IsValidTab() && location.href.search('=') === -1) {
    location.href += 'LicenseMonitor'; // redirect to monitor tab id
}
let oldPwStart = location.href.search('/pw=');
if (oldPwStart > 0) { // fallback for older versions before using tab ids
    location.href = location.href.substring(0, oldPwStart) + '/LicenseMonitor&' + location.href.substring(oldPwStart + 1);
}
if (location.href.search('/LicenseMonitor') > 0) {
    setTimeout(function () { location.reload(); }, 60000); // reload every 60 seconds if on monitor tab
}
function GetValidOrigin() {
    let posTab = location.href.lastIndexOf('/');
    return location.href.substring(0, posTab);
}
function GoToTab(tab) {
    let hrefNew = GetValidOrigin() + '/' + tab;
    let posParams = location.href.search('&');
    if (posParams > 0) {
        hrefNew += location.href.substring(posParams);
    }
    location.assign(hrefNew);
}
function ExecuteLogin(ele) {
    if (event.key === 'Enter') {
        let pos = location.href.search('&');
        let hrefCut = pos > 0 ? location.href.substring(0, pos) : location.href;
        location.assign(hrefCut + '&pw=' + btoa(ele.value));
    }
}
function GetTodayStart(timet) {
    let dt = luxon.DateTime.fromSeconds(timet);
    return dt.set({ hour: 0, minute: 0, second: 0, millisecond: 0 });
}
function GetTodayEnd(timet) {
    let dt = luxon.DateTime.fromSeconds(timet).plus({ days: 1 });
    return dt.set({ hour: 0, minute: 0, second: 0, millisecond: 0 });
}
function SelectAllFeatures(sn) {
    let checkVal = document.getElementById(sn + '_toggleall').checked ? 'checked' : '';
    $('input:checkbox[name=' + sn + '_features]').prop('checked', checkVal);
}
function OpenDefaultCharts(sn) {
    window.open(GetValidOrigin() + '/DefaultCharts&sn=' + sn, '_blank');
}
function OpenCustomChart(sn) {
    let features = $('input:checkbox[name=' + sn + '_features]:checked').map(function () { return this.value; }).get();
    let dateFrom = document.getElementById('dateFrom').value;
    let dateTo = document.getElementById('dateTo').value;
    let idGroup = document.getElementById('groupBy').value;
    let parameters = '/CustomChart&sn=' + sn + '&features=' + features + '&from=' + dateFrom + '&to=' + dateTo + '&group=' + idGroup;
    window.open(GetValidOrigin() + parameters, '_blank');
}
function UpdateChartsFromFeatureSelection() {
    let select = document.getElementById('featureSelect');
    let canvasList = document.querySelectorAll('canvas');
    canvasList.forEach((canvas) => { canvas.style.display = 'none'; });
    canvasList.forEach((canvas) => { if (canvas.id.includes(select.options[select.selectedIndex].text)) { canvas.style.display = 'block'; } });
}
$(document).ready(() => { $('#featureSelect').change(UpdateChartsFromFeatureSelection).change(); }); // react on feature selection on chart page